/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define maxc 310
#define baza 10
#define powbaza 1
#define fwd 5

typedef int BigNum[maxc];

int compare(BigNum, BigNum);
void add(BigNum, BigNum, BigNum);
void sub(BigNum, BigNum, BigNum);

BigNum K;
int N;
char s[maxc];

void read_input() {
	freopen("arbsort.in", "r", stdin);
	scanf("%d %s", &N, s);

	int l = strlen(s);
	for (int i = l - 1; i >= 0; i -= powbaza) {
		int r = 0;
		for (int j = i - powbaza + 1; j <= i; j++)
			if (j >= 0)
				r = (r * 10) + (int) (s[j] - '0');
		K[0]++;
		K[K[0]] = r;
	}
}

#define NMAX 201

BigNum cnt[NMAX][NMAX], sum[NMAX], vaux;

void dp() {
	int i, j;
	
	// Initializare: cnt[N-1][1 <= i <= N-1] = 1.
	sum[N][0] = 1;
	for (i = N - 1; i >= 1; i--) {
		cnt[N - 1][i][0] = cnt[N - 1][i][1] = 1;
		add(cnt[N - 1][i], sum[i + 1], sum[i]);
	}

	for (i = N - 2; i >= 1; i--) {
		memset(sum[i + 1], 0, sizeof(BigNum));
		for (j = i; j >= 1; j--) {
			memcpy(cnt[i][j], sum[j], sizeof(BigNum));
			add(cnt[i][j], sum[j + 1], sum[j]);
		}
	}
}

void print_vector() {
	int i, j;
	
	freopen("arbsort.out", "w", stdout);

	printf("0");
	for (i = j = 1; i < N; i++) {
		while (compare(K, cnt[i][j]) > 0) {
			sub(K, cnt[i][j], vaux);
			memcpy(K, vaux, sizeof(BigNum));
			j++;
		}
		printf(" %d", j);
	}
	printf("\n");
}

int main() {
	read_input();
	dp();
	print_vector();
	return 0;
}

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
int compare(BigNum n1, BigNum n2) {
	int i, res;

	if (n1[0] > n2[0]) return 1;
	if (n1[0] < n2[0]) return -1;

	for (res = 0, i = n1[0]; i >= 1; i--)
		if (n1[i] > n2[i]) {
			res=1;
			break;
		} else if (n1[i] < n2[i]) {
			res=-1;
			break;
		}

	return res;
}

void add(BigNum n1, BigNum n2, BigNum rez) {
	int i, ndigits = n1[0];

	memset(rez, 0, (rez[0] + 1) * sizeof(int));
	rez[0] = 0;

	if (n2[0] > ndigits)
		ndigits = n2[0];

	for (i = 1; i <= ndigits; i++)
		rez[i] = n1[i] + n2[i];

	for (i = 1 ;i <= (ndigits+fwd); i++)
		if (rez[i] >= baza) {
			rez[i+1] += (rez[i]/baza);
			  rez[i] %= baza;
		}

	for (i = (ndigits+fwd); i >= 1; i--)
		if (rez[i] > 0) {
			rez[0] = i;
			break;
		}

	if (!rez[0])
		rez[0] = 1;
}

void sub(BigNum n1, BigNum n2, BigNum rez) {
	int i, ndigits = n1[0];

	memset(rez, 0, (rez[0] + 1) * sizeof(int));
	rez[0] = 0;

	for (i = 1; i <= ndigits; i++)
		rez[i] = n1[i] - n2[i];

	for (i = 1; i <= ndigits; i++)
		while (rez[i] < 0) {
			rez[i] += baza;
			rez[i+1]--;
		}

	for (rez[0] = 1, i = ndigits; i >= 1; i--)
		if (rez[i]) {
			rez[0] = i;
			break;
		}

	if (!rez[0])
		rez[0] = 1;
}
