// Marius Stroe
#include <iostream>
#include <cassert>
using namespace std;

const char iname[] = "snpid.in";
const char oname[] = "snpid.out";
const int MAX_N = 100005;

typedef long long i64;

int n, values[MAX_N]; i64 answer[MAX_N];
int inv_values[MAX_N]; i64 cnts[MAX_N], sums[MAX_N];

void update(i64 aib[], int idx, i64 value) {
    for (; idx <= n; idx += idx & -idx)
        aib[idx] += value;
}

i64 query(i64 aib[], int idx) {
    i64 sum = 0;
    for (; idx >= 1; idx -= idx & -idx)
        sum += aib[idx];
    return sum;
}

void solve() {
    for (int i = 1; i <= n; ++ i) {
        int xcoord = inv_values[i]; 

        update(cnts, xcoord, 1);
        i64 left_down_cnts = query(cnts, xcoord);
        update(sums, xcoord, left_down_cnts);
        i64 left_down_sums = query(sums, xcoord);

        if (left_down_cnts == 1) {
            answer[n - xcoord + 1] = 0;
        } else {
            answer[n - xcoord + 1] = 
                (left_down_cnts - 1) * left_down_cnts + 
                (left_down_sums - left_down_cnts) -
                left_down_cnts * (left_down_cnts - 1) -
                (left_down_cnts - 1);
        }
    }
}

int main(void) {
    FILE *fi = fopen(iname, "r");
    fscanf(fi, "%d", &n);

    assert(1 <= n && n <= 1e5);
    for (int i = 1; i <= n; ++ i) {
        fscanf(fi, "%d", &values[i]);
        assert(1 <= values[i] && values[i] <= n);
        inv_values[n - values[i] + 1] = n - i + 1;
    }
    fclose(fi);

    solve();

    FILE *fo = fopen(oname, "w");
    for (int i = 1; i <= n; ++ i)
        fprintf(fo, "%lld\n", answer[i]);
    fclose(fo);
    return 0;
}
